<script>
    import BDD from '../BDD';

    import {
        onMounted,
        ref,
        watch
    } from 'vue';


    export default {
        name: 'Header',

        setup() {
            //A retirer
            class Restaurant {
                constructor(name, note, image, drive_time) {
                    this.name = name
                    this.note = note
                    this.image = image
                    this.drive_time = drive_time
                }
            };

            let data_restaurant = ref([]);

            let all_restaurant = [];

            const makeDataRestaurant = () => {

                let three_restaurant = [];

                for (const restaurant of BDD) {

                    const new_restaurant = new Restaurant(restaurant.name, restaurant.note, restaurant.image,
                        restaurant.drive_time);

                    all_restaurant.push(new_restaurant);


                    if (three_restaurant.length === 2) {

                        three_restaurant.push(new_restaurant);

                        data_restaurant.value.push(three_restaurant);

                        three_restaurant = [];

                    } else {

                        three_restaurant.push(new_restaurant);
                    }
                };
            };
            //A retirer

            let user_search = ref('');
            let search_restaurant = ref([]);

            watch(user_search, (new_value) => {

                let regex = new RegExp(new_value.toLowerCase());

                let new_search_restaurant = all_restaurant.filter(restaurant => regex.test(restaurant.name
                    .toLowerCase()));

                new_value == 0 ? search_restaurant.value = [] : search_restaurant.value = new_search_restaurant;

            });

            onMounted(makeDataRestaurant);

            return {
                data_restaurant,
                user_search,
                search_restaurant,
            }
        },
    }
</script>


<template>
    <header>
        <router-link :to="{name: 'Home'}">
            <img src="https://d3i4yxtzktqr9n.cloudfront.net/web-eats-v2/ee037401cb5d31b23cf780808ee4ec1f.svg"
                alt="Logo">
        </router-link>
        <router-link :to="({name: 'Login'})">Connexion</router-link>
        <div class="wrapper-input">
            <input type="text" name="" id="" placeholder="De quoi avez vous envie ?" v-model="user_search">
            <div class="search">
                <router-link v-for="(restaurant) in search_restaurant"
                    :to="{name: 'Restaurant', params: { name: restaurant.name, note: restaurant.note, image: restaurant.image, time: restaurant.drive_time } }">
                    <div class="container-restaurant-search">
                        <div class="wrapper-img">
                            <img :src="restaurant.image" alt="Image de {{ restaurant.name }}">
                        </div>
                        <h2> {{ restaurant.name }}</h2>
                    </div>
                </router-link>
            </div>
        </div>
    </header>
</template>

<style lang="scss">
    header {
        height: 120px;
        max-width: 100%;
        display: flex;
        align-items: center;
        justify-content: space-between;

        img {
            max-width: 200px;
        }

        .wrapper-input {
            position: relative;

            input {
                background-color: #f6f6f6;
                border: none;
                height: 50px;
                width: 300px;
                outline: none;
                padding-left: 20px;
            }

            .search {
                position: absolute;
                top: 100%;
                width: 100%;
                background-color: white;
                border: solid .1px grey;

                .container-restaurant-search {
                    display: flex;
                    align-items: center;
                    padding: 10px;

                    &:hover {
                        background-color: #f6f6f6;
                    }

                    .wrapper-img {
                        height: 60px;
                        width: 60px;
                        margin-right: 25px;
                        border-radius: 50%;
                        overflow: hidden;

                        img {
                            height: 100%;
                            width: auto;
                        }
                    }

                    h2 {
                        font-size: 1.2rem;
                    }
                }
            }
        }
    }
</style>